Index: serefpolicy-contrib-20140730/pyzor.if
===================================================================
--- serefpolicy-contrib-20140730.orig/pyzor.if
+++ serefpolicy-contrib-20140730/pyzor.if
@@ -2,7 +2,7 @@
 
 ########################################
 ## <summary>
-##	Role access for pyzor.
+##	Role access for pyzor
 ## </summary>
 ## <param name="role">
 ##	<summary>
@@ -14,31 +14,30 @@
 ##	User domain for the role
 ##	</summary>
 ## </param>
+## <rolecap/>
 #
 interface(`pyzor_role',`
 	gen_require(`
-		attribute_role pyzor_roles;
-		type pyzor_t, pyzor_exec_t, pyzor_home_t;
-		type pyzor_tmp_t;
+		type pyzor_t, pyzor_exec_t;
+		type pyzor_home_t, pyzor_var_lib_t, pyzor_tmp_t;
 	')
 
-	roleattribute $1 pyzor_roles;
+	role $1 types pyzor_t;
 
+	# Transition from the user domain to the derived domain.
 	domtrans_pattern($2, pyzor_exec_t, pyzor_t)
 
-	allow $2 pyzor_t:process { ptrace signal_perms };
+	# allow ps to show pyzor and allow the user to kill it 
 	ps_process_pattern($2, pyzor_t)
-
-	allow $2 { pyzor_home_t pyzor_tmp_t }:dir { manage_dir_perms relabel_dir_perms };
-	allow $2  { pyzor_home_t pyzor_tmp_t }:file { manage_file_perms relabel_file_perms };
-	allow $2 pyzor_home_t:lnk_file { manage_lnk_file_perms relabel_lnk_file_perms };
-
-	userdom_user_home_dir_filetrans($2, pyzor_home_t, dir, ".pyzor")
+	allow $2 pyzor_t:process signal_perms;
+	tunable_policy(`deny_ptrace',`',`
+		allow $2 pyzor_t:process ptrace;
+	')
 ')
 
 ########################################
 ## <summary>
-##	Send generic signals to pyzor.
+##	Send generic signals to pyzor
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -69,6 +68,7 @@ interface(`pyzor_domtrans',`
 		type pyzor_exec_t, pyzor_t;
 	')
 
+	files_search_usr($1)
 	corecmd_search_bin($1)
 	domtrans_pattern($1, pyzor_exec_t, pyzor_t)
 ')
@@ -88,14 +88,15 @@ interface(`pyzor_exec',`
 		type pyzor_exec_t;
 	')
 
+	files_search_usr($1)
 	corecmd_search_bin($1)
 	can_exec($1, pyzor_exec_t)
 ')
 
 ########################################
 ## <summary>
-##	All of the rules required to
-##	administrate an pyzor environment.
+##	All of the rules required to administrate
+##	an pyzor environment
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -104,33 +105,37 @@ interface(`pyzor_exec',`
 ## </param>
 ## <param name="role">
 ##	<summary>
-##	Role allowed access.
+##	The role to be allowed to manage the pyzor domain.
 ##	</summary>
 ## </param>
 ## <rolecap/>
 #
 interface(`pyzor_admin',`
 	gen_require(`
-		type pyzord_t, pyzord_initrc_exec_t, pyzord_log_t;
-		type pyzor_var_lib_t, pyzor_etc_t;
+		type pyzord_t, pyzor_tmp_t, pyzord_log_t;
+		type pyzor_etc_t, pyzor_var_lib_t, pyzord_initrc_exec_t;
 	')
 
-	allow $1 pyzord_t:process { ptrace signal_perms };
+	allow $1 pyzord_t:process signal_perms;
 	ps_process_pattern($1, pyzord_t)
+	tunable_policy(`deny_ptrace',`',`
+		allow $1 pyzord_t:process ptrace;
+	')
 
 	init_labeled_script_domtrans($1, pyzord_initrc_exec_t)
 	domain_system_change_exemption($1)
 	role_transition $2 pyzord_initrc_exec_t system_r;
 	allow $2 system_r;
 
-	files_search_etc($1)
-	admin_pattern($1, pyzor_etc_t)
+	files_list_tmp($1)
+	admin_pattern($1, pyzor_tmp_t)
 
-	logging_search_logs($1)
+	logging_list_logs($1)
 	admin_pattern($1, pyzord_log_t)
 
-	files_search_var_lib($1)
-	admin_pattern($1, pyzor_var_lib_t)
+	files_list_etc($1)
+	admin_pattern($1, pyzor_etc_t)
 
-	pyzor_role($2, $1)
+	files_list_var_lib($1)
+	admin_pattern($1, pyzor_var_lib_t)
 ')
Index: serefpolicy-contrib-20140730/pyzor.te
===================================================================
--- serefpolicy-contrib-20140730.orig/pyzor.te
+++ serefpolicy-contrib-20140730/pyzor.te
@@ -5,57 +5,78 @@ policy_module(pyzor, 2.3.0)
 # Declarations
 #
 
-attribute_role pyzor_roles;
-roleattribute system_r pyzor_roles;
+ifdef(`distro_redhat',`
+	gen_require(`
+		type spamc_t, spamc_exec_t, spamd_t;
+		type spamd_initrc_exec_t, spamd_exec_t, spamc_tmp_t;
+		type spamd_log_t, spamd_var_lib_t, spamd_etc_t;
+		type spamc_tmp_t, spamc_home_t;
+	')
+
+	typealias spamc_t alias pyzor_t;
+	typealias spamc_exec_t alias pyzor_exec_t;
+	typealias spamd_t alias pyzord_t;
+	typealias spamd_initrc_exec_t alias pyzord_initrc_exec_t;
+	typealias spamd_exec_t alias pyzord_exec_t;
+	typealias spamc_tmp_t alias pyzor_tmp_t;
+	typealias spamd_log_t alias pyzor_log_t;
+	typealias spamd_log_t alias pyzord_log_t;
+	typealias spamd_var_lib_t alias pyzor_var_lib_t;
+	typealias spamd_etc_t alias pyzor_etc_t;
+	typealias spamc_home_t alias pyzor_home_t;
+	typealias spamc_home_t alias user_pyzor_home_t;
+',`
+	type pyzor_t;
+	type pyzor_exec_t;
+	typealias pyzor_t alias { user_pyzor_t staff_pyzor_t sysadm_pyzor_t };
+	typealias pyzor_t alias { auditadm_pyzor_t secadm_pyzor_t };
+	application_domain(pyzor_t, pyzor_exec_t)
+	ubac_constrained(pyzor_t)
+	role system_r types pyzor_t;
+
+	type pyzor_etc_t;
+	files_config_file(pyzor_etc_t)
+
+	type pyzor_home_t;
+	typealias pyzor_home_t alias { user_pyzor_home_t staff_pyzor_home_t sysadm_pyzor_home_t };
+	typealias pyzor_home_t alias { auditadm_pyzor_home_t secadm_pyzor_home_t };
+	userdom_user_home_content(pyzor_home_t)
+
+	type pyzor_tmp_t;
+	typealias pyzor_tmp_t alias { user_pyzor_tmp_t staff_pyzor_tmp_t sysadm_pyzor_tmp_t };
+	typealias pyzor_tmp_t alias { auditadm_pyzor_tmp_t secadm_pyzor_tmp_t };
+	files_tmp_file(pyzor_tmp_t)
+	ubac_constrained(pyzor_tmp_t)
+
+	type pyzor_var_lib_t;
+	typealias pyzor_var_lib_t alias { user_pyzor_var_lib_t staff_pyzor_var_lib_t sysadm_pyzor_var_lib_t };
+	typealias pyzor_var_lib_t alias { auditadm_pyzor_var_lib_t secadm_pyzor_var_lib_t };
+	files_type(pyzor_var_lib_t)
+	ubac_constrained(pyzor_var_lib_t)
+
+	type pyzord_t;
+	type pyzord_exec_t;
+	init_daemon_domain(pyzord_t, pyzord_exec_t)
 
-type pyzor_t;
-type pyzor_exec_t;
-typealias pyzor_t alias { user_pyzor_t staff_pyzor_t sysadm_pyzor_t };
-typealias pyzor_t alias { auditadm_pyzor_t secadm_pyzor_t };
-userdom_user_application_domain(pyzor_t, pyzor_exec_t)
-role pyzor_roles types pyzor_t;
-
-type pyzor_etc_t;
-files_type(pyzor_etc_t)
-
-type pyzor_home_t;
-typealias pyzor_home_t alias { user_pyzor_home_t staff_pyzor_home_t sysadm_pyzor_home_t };
-typealias pyzor_home_t alias { auditadm_pyzor_home_t secadm_pyzor_home_t };
-userdom_user_home_content(pyzor_home_t)
-
-type pyzor_tmp_t;
-typealias pyzor_tmp_t alias { user_pyzor_tmp_t staff_pyzor_tmp_t sysadm_pyzor_tmp_t };
-typealias pyzor_tmp_t alias { auditadm_pyzor_tmp_t secadm_pyzor_tmp_t };
-userdom_user_tmp_file(pyzor_tmp_t)
-
-type pyzor_var_lib_t;
-typealias pyzor_var_lib_t alias { user_pyzor_var_lib_t staff_pyzor_var_lib_t sysadm_pyzor_var_lib_t };
-typealias pyzor_var_lib_t alias { auditadm_pyzor_var_lib_t secadm_pyzor_var_lib_t };
-files_type(pyzor_var_lib_t)
-ubac_constrained(pyzor_var_lib_t)
-
-type pyzord_t;
-type pyzord_exec_t;
-init_daemon_domain(pyzord_t, pyzord_exec_t)
-
-type pyzord_initrc_exec_t;
-init_script_file(pyzord_initrc_exec_t)
-
-type pyzord_log_t;
-logging_log_file(pyzord_log_t)
+	type pyzord_log_t;
+	logging_log_file(pyzord_log_t)
+')
 
 ########################################
 #
-# Local policy
+# Pyzor client local policy
 #
 
+allow pyzor_t self:udp_socket create_socket_perms;
+
 manage_dirs_pattern(pyzor_t, pyzor_home_t, pyzor_home_t)
 manage_files_pattern(pyzor_t, pyzor_home_t, pyzor_home_t)
 manage_lnk_files_pattern(pyzor_t, pyzor_home_t, pyzor_home_t)
-userdom_user_home_dir_filetrans(pyzor_t, pyzor_home_t, dir, ".pyzor")
+userdom_user_home_dir_filetrans(pyzor_t, pyzor_home_t, { dir file lnk_file })
 
 allow pyzor_t pyzor_var_lib_t:dir list_dir_perms;
 read_files_pattern(pyzor_t, pyzor_var_lib_t, pyzor_var_lib_t)
+files_search_var_lib(pyzor_t)
 
 manage_files_pattern(pyzor_t, pyzor_tmp_t, pyzor_tmp_t)
 manage_dirs_pattern(pyzor_t, pyzor_tmp_t, pyzor_tmp_t)
@@ -67,41 +88,28 @@ kernel_read_system_state(pyzor_t)
 corecmd_list_bin(pyzor_t)
 corecmd_getattr_bin_files(pyzor_t)
 
-corenet_all_recvfrom_unlabeled(pyzor_t)
-corenet_all_recvfrom_netlabel(pyzor_t)
 corenet_tcp_sendrecv_generic_if(pyzor_t)
+corenet_udp_sendrecv_generic_if(pyzor_t)
 corenet_tcp_sendrecv_generic_node(pyzor_t)
-
-corenet_sendrecv_http_client_packets(pyzor_t)
+corenet_udp_sendrecv_generic_node(pyzor_t)
+corenet_tcp_sendrecv_all_ports(pyzor_t)
+corenet_udp_sendrecv_all_ports(pyzor_t)
 corenet_tcp_connect_http_port(pyzor_t)
-corenet_tcp_sendrecv_http_port(pyzor_t)
 
 dev_read_urand(pyzor_t)
 
-fs_getattr_all_fs(pyzor_t)
-fs_search_auto_mountpoints(pyzor_t)
+fs_getattr_xattr_fs(pyzor_t)
+
 
 auth_use_nsswitch(pyzor_t)
 
-miscfiles_read_localization(pyzor_t)
 
 mta_read_queue(pyzor_t)
 
-tunable_policy(`use_nfs_home_dirs',`
-	fs_manage_nfs_dirs(pyzor_t)
-	fs_manage_nfs_files(pyzor_t)
-	fs_manage_nfs_symlinks(pyzor_t)
-')
-
-tunable_policy(`use_samba_home_dirs',`
-	fs_manage_cifs_dirs(pyzor_t)
-	fs_manage_cifs_files(pyzor_t)
-	fs_manage_cifs_symlinks(pyzor_t)
-')
+userdom_dontaudit_search_user_home_dirs(pyzor_t)
 
 optional_policy(`
-	amavis_manage_lib_files(pyzor_t)
-	amavis_manage_spool_files(pyzor_t)
+	antivirus_manage_db(pyzor_t)
 ')
 
 optional_policy(`
@@ -111,25 +119,24 @@ optional_policy(`
 
 ########################################
 #
-# Daemon local policy
+# Pyzor server local policy
 #
 
-allow pyzord_t pyzor_var_lib_t:dir setattr_dir_perms;
+allow pyzord_t self:udp_socket create_socket_perms;
+
 manage_files_pattern(pyzord_t, pyzor_var_lib_t, pyzor_var_lib_t)
+allow pyzord_t pyzor_var_lib_t:dir setattr;
 files_var_lib_filetrans(pyzord_t, pyzor_var_lib_t, { file dir })
 
+read_files_pattern(pyzord_t, pyzor_etc_t, pyzor_etc_t)
 allow pyzord_t pyzor_etc_t:dir list_dir_perms;
-allow pyzord_t pyzor_etc_t:file read_file_perms;
-allow pyzord_t pyzor_etc_t:lnk_file read_lnk_file_perms;
 
+can_exec(pyzord_t, pyzor_exec_t)
+
+manage_files_pattern(pyzord_t, pyzord_log_t, pyzord_log_t)
 allow pyzord_t pyzord_log_t:dir setattr_dir_perms;
-append_files_pattern(pyzord_t, pyzord_log_t, pyzord_log_t)
-create_files_pattern(pyzord_t, pyzord_log_t, pyzord_log_t)
-setattr_files_pattern(pyzord_t, pyzord_log_t, pyzord_log_t)
 logging_log_filetrans(pyzord_t, pyzord_log_t, { file dir })
 
-can_exec(pyzord_t, pyzor_exec_t)
-
 kernel_read_kernel_sysctls(pyzord_t)
 kernel_read_system_state(pyzord_t)
 
@@ -137,24 +144,25 @@ dev_read_urand(pyzord_t)
 
 corecmd_exec_bin(pyzord_t)
 
-corenet_all_recvfrom_unlabeled(pyzord_t)
 corenet_all_recvfrom_netlabel(pyzord_t)
 corenet_udp_sendrecv_generic_if(pyzord_t)
 corenet_udp_sendrecv_generic_node(pyzord_t)
+corenet_udp_sendrecv_all_ports(pyzord_t)
 corenet_udp_bind_generic_node(pyzord_t)
-
-corenet_sendrecv_pyzor_server_packets(pyzord_t)
 corenet_udp_bind_pyzor_port(pyzord_t)
-corenet_udp_sendrecv_pyzor_port(pyzord_t)
+corenet_sendrecv_pyzor_server_packets(pyzord_t)
 
-auth_use_nsswitch(pyzord_t)
 
-logging_send_syslog_msg(pyzord_t)
+auth_use_nsswitch(pyzord_t)
 
 locallogin_dontaudit_use_fds(pyzord_t)
 
-miscfiles_read_localization(pyzord_t)
 
+# Do not audit attempts to access /root.
 userdom_dontaudit_search_user_home_dirs(pyzord_t)
 
 mta_manage_spool(pyzord_t)
+
+optional_policy(`
+	logging_send_syslog_msg(pyzord_t)
+')
Index: serefpolicy-contrib-20140730/qemu.if
===================================================================
--- serefpolicy-contrib-20140730.orig/qemu.if
+++ serefpolicy-contrib-20140730/qemu.if
@@ -1,19 +1,21 @@
-## <summary>QEMU machine emulator and virtualizer.</summary>
+## <summary>QEMU machine emulator and virtualizer</summary>
 
-#######################################
+########################################
 ## <summary>
-##	The template to define a qemu domain.
+##	Creates types and rules for a basic
+##	qemu process domain.
 ## </summary>
-## <param name="domain_prefix">
+## <param name="prefix">
 ##	<summary>
-##	Domain prefix to be used.
+##	Prefix for the domain.
 ##	</summary>
 ## </param>
 #
 template(`qemu_domain_template',`
+
 	##############################
 	#
-	# Declarations
+	# Local Policy
 	#
 
 	type $1_t;
@@ -22,9 +24,12 @@ template(`qemu_domain_template',`
 	type $1_tmp_t;
 	files_tmp_file($1_tmp_t)
 
+	type $1_tmpfs_t;
+	files_tmpfs_file($1_tmpfs_t)
+
 	##############################
 	#
-	# Policy
+	# Local Policy
 	#
 
 	allow $1_t self:capability { dac_read_search dac_override };
@@ -39,9 +44,12 @@ template(`qemu_domain_template',`
 	manage_files_pattern($1_t, $1_tmp_t, $1_tmp_t)
 	files_tmp_filetrans($1_t, $1_tmp_t, { file dir })
 
+	manage_dirs_pattern($1_t, $1_tmpfs_t, $1_tmpfs_t)
+	manage_files_pattern($1_t, $1_tmpfs_t, $1_tmpfs_t)
+	files_tmpfs_filetrans($1_t, $1_tmpfs_t, { file dir })
+
 	kernel_read_system_state($1_t)
 
-	corenet_all_recvfrom_unlabeled($1_t)
 	corenet_all_recvfrom_netlabel($1_t)
 	corenet_tcp_sendrecv_generic_if($1_t)
 	corenet_tcp_sendrecv_generic_node($1_t)
@@ -61,7 +69,6 @@ template(`qemu_domain_template',`
 
 	fs_list_inotifyfs($1_t)
 	fs_rw_anon_inodefs_files($1_t)
-	fs_rw_tmpfs_files($1_t)
 
 	storage_raw_write_removable_device($1_t)
 	storage_raw_read_removable_device($1_t)
@@ -70,11 +77,10 @@ template(`qemu_domain_template',`
 	term_getattr_pty_fs($1_t)
 	term_use_generic_ptys($1_t)
 
-	miscfiles_read_localization($1_t)
 
 	sysnet_read_config($1_t)
 
-	userdom_use_user_terminals($1_t)
+	userdom_use_inherited_user_terminals($1_t)
 	userdom_attach_admin_tun_iface($1_t)
 
 	optional_policy(`
@@ -98,38 +104,12 @@ template(`qemu_domain_template',`
 
 ########################################
 ## <summary>
-##	Role access for qemu.
-## </summary>
-## <param name="role">
-##	<summary>
-##	Role allowed access.
-##	</summary>
-## </param>
-## <param name="domain">
-##	<summary>
-##	User domain for the role.
-##	</summary>
-## </param>
-#
-template(`qemu_role',`
-	gen_require(`
-		type qemu_t;
-	')
-
-	qemu_run($2, $1)
-
-	allow $2 qemu_t:process { ptrace signal_perms };
-	ps_process_pattern($2, qemu_t)
-')
-
-########################################
-## <summary>
 ##	Execute a domain transition to run qemu.
 ## </summary>
 ## <param name="domain">
-##	<summary>
+## <summary>
 ##	Domain allowed to transition.
-##	</summary>
+## </summary>
 ## </param>
 #
 interface(`qemu_domtrans',`
@@ -137,18 +117,17 @@ interface(`qemu_domtrans',`
 		type qemu_t, qemu_exec_t;
 	')
 
-	corecmd_search_bin($1)
 	domtrans_pattern($1, qemu_exec_t, qemu_t)
 ')
 
 ########################################
 ## <summary>
-##	Execute a qemu in the caller domain.
+##	Execute a qemu in the callers domain
 ## </summary>
 ## <param name="domain">
-##	<summary>
+## <summary>
 ##	Domain allowed access.
-##	</summary>
+## </summary>
 ## </param>
 #
 interface(`qemu_exec',`
@@ -156,15 +135,12 @@ interface(`qemu_exec',`
 		type qemu_exec_t;
 	')
 
-	corecmd_search_bin($1)
 	can_exec($1, qemu_exec_t)
 ')
 
 ########################################
 ## <summary>
-##	Execute qemu in the qemu domain,
-##	and allow the specified role the
-##	qemu domain.
+##	Execute qemu in the qemu domain.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -173,23 +149,25 @@ interface(`qemu_exec',`
 ## </param>
 ## <param name="role">
 ##	<summary>
-##	Role allowed access.
+##	The role to allow the qemu domain.
 ##	</summary>
 ## </param>
 ## <rolecap/>
 #
 interface(`qemu_run',`
 	gen_require(`
-		attribute_role qemu_roles;
+		type qemu_t;
 	')
 
 	qemu_domtrans($1)
-	roleattribute $2 qemu_roles;
+	role $2 types qemu_t;
+	allow qemu_t $1:process signull;
+	allow $1 qemu_t:process signull;
 ')
 
 ########################################
 ## <summary>
-##	Read qemu process state files.
+##	Allow the domain to read state files in /proc.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -202,15 +180,12 @@ interface(`qemu_read_state',`
 		type qemu_t;
 	')
 
-	kernel_search_proc($1)
-	allow $1 qemu_t:dir list_dir_perms;
-	allow $1 qemu_t:file read_file_perms;
-	allow $1 qemu_t:lnk_file read_lnk_file_perms;
+	read_files_pattern($1, qemu_t, qemu_t)
 ')
 
 ########################################
 ## <summary>
-##	Set qemu scheduler.
+##	Set the schedule on qemu.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -228,7 +203,7 @@ interface(`qemu_setsched',`
 
 ########################################
 ## <summary>
-##	Send generic signals to qemu.
+##	Send a signal to qemu.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -246,7 +221,7 @@ interface(`qemu_signal',`
 
 ########################################
 ## <summary>
-##	Send kill signals to qemu.
+##	Send a sigill to qemu
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -264,48 +239,68 @@ interface(`qemu_kill',`
 
 ########################################
 ## <summary>
-##	Execute a domain transition to
-##	run qemu unconfined.
+##	Execute qemu_exec_t 
+##	in the specified domain but do not
+##	do it automatically. This is an explicit
+##	transition, requiring the caller to use setexeccon().
 ## </summary>
+## <desc>
+##	<p>
+##	Execute qemu_exec_t 
+##	in the specified domain.  This allows
+##	the specified domain to qemu programs
+##	on these filesystems in the specified
+##	domain.
+##	</p>
+## </desc>
 ## <param name="domain">
 ##	<summary>
-##	Domain allowed to transition.
+##	Domain allowed access.
+##	</summary>
+## </param>
+## <param name="target_domain">
+##	<summary>
+##	The type of the new process.
 ##	</summary>
 ## </param>
 #
-interface(`qemu_domtrans_unconfined',`
+interface(`qemu_spec_domtrans',`
 	gen_require(`
-		type unconfined_qemu_t, qemu_exec_t;
+		type qemu_exec_t;
 	')
+  
+	read_lnk_files_pattern($1, qemu_exec_t, qemu_exec_t)
+	domain_transition_pattern($1, qemu_exec_t, $2)
+  	domain_entry_file($2,qemu_exec_t)
+	can_exec($1,qemu_exec_t)
 
-	corecmd_search_bin($1)
-	domtrans_pattern($1, qemu_exec_t, unconfined_qemu_t)
+	allow $2 $1:fd use;
+	allow $2 $1:fifo_file rw_fifo_file_perms;
+	allow $2 $1:process sigchld;
 ')
 
 ########################################
 ## <summary>
-##	Create, read, write, and delete
-##	qemu temporary directories.
+##	Execute qemu unconfined programs in the role.
 ## </summary>
-## <param name="domain">
+## <param name="role">
 ##	<summary>
-##	Domain allowed access.
+##	The role to allow the qemu unconfined domain.
 ##	</summary>
 ## </param>
 #
-interface(`qemu_manage_tmp_dirs',`
+interface(`qemu_unconfined_role',`
 	gen_require(`
-		type qemu_tmp_t;
+		type unconfined_qemu_t;
+		type qemu_t;
 	')
-
-	files_search_tmp($1)
-	manage_dirs_pattern($1, qemu_tmp_t, qemu_tmp_t)
+	role $1 types unconfined_qemu_t;
+	role $1 types qemu_t;
 ')
 
 ########################################
 ## <summary>
-##	Create, read, write, and delete
-##	qemu temporary files.
+##	Manage qemu temporary dirs.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -313,58 +308,41 @@ interface(`qemu_manage_tmp_dirs',`
 ##	</summary>
 ## </param>
 #
-interface(`qemu_manage_tmp_files',`
+interface(`qemu_manage_tmp_dirs',`
 	gen_require(`
 		type qemu_tmp_t;
 	')
 
-	files_search_tmp($1)
-	manage_files_pattern($1, qemu_tmp_t, qemu_tmp_t)
+	manage_dirs_pattern($1, qemu_tmp_t, qemu_tmp_t)
 ')
 
 ########################################
 ## <summary>
-##	Execute qemu in a specified domain.
+##	Manage qemu temporary files.
 ## </summary>
-## <desc>
-##	<p>
-##	Execute qemu in a specified domain.
-##	</p>
-##	<p>
-##	No interprocess communication (signals, pipes,
-##	etc.) is provided by this interface since
-##	the domains are not owned by this module.
-##	</p>
-## </desc>
-## <param name="source_domain">
-##	<summary>
-##	Domain allowed to transition.
-##	</summary>
-## </param>
-## <param name="target_domain">
+## <param name="domain">
 ##	<summary>
-##	Domain to transition to.
+##	Domain allowed access.
 ##	</summary>
 ## </param>
 #
-interface(`qemu_spec_domtrans',`
+interface(`qemu_manage_tmp_files',`
 	gen_require(`
-		type qemu_exec_t;
+		type qemu_tmp_t;
 	')
 
-	corecmd_search_bin($1)
-	domain_auto_trans($1, qemu_exec_t, $2)
+	manage_files_pattern($1, qemu_tmp_t, qemu_tmp_t)
 ')
 
-######################################
+########################################
 ## <summary>
-##	Make qemu executable files an
-##	entrypoint for the specified domain.
+##     Make qemu_exec_t an entrypoint for
+##     the specified domain.
 ## </summary>
 ## <param name="domain">
-##	<summary>
-##	The domain for which qemu_exec_t is an entrypoint.
-##	</summary>
+##     <summary>
+##     The domain for which qemu_exec_t is an entrypoint.
+##     </summary>
 ## </param>
 #
 interface(`qemu_entry_type',`
Index: serefpolicy-contrib-20140730/qemu.te
===================================================================
--- serefpolicy-contrib-20140730.orig/qemu.te
+++ serefpolicy-contrib-20140730/qemu.te
@@ -6,28 +6,58 @@ policy_module(qemu, 1.8.0)
 #
 
 ## <desc>
-##	<p>
-##	Determine whether qemu has full
-##	access to the network.
-##	</p>
+## <p>
+## Allow qemu to connect fully to the network
+## </p>
 ## </desc>
 gen_tunable(qemu_full_network, false)
 
-attribute_role qemu_roles;
-roleattribute system_r qemu_roles;
+## <desc>
+## <p>
+## Allow qemu to use cifs/Samba file systems
+## </p>
+## </desc>
+gen_tunable(qemu_use_cifs, true)
+
+## <desc>
+## <p>
+## Allow qemu to use serial/parallel communication ports
+## </p>
+## </desc>
+gen_tunable(qemu_use_comm, false)
 
-type qemu_exec_t;
-application_executable_file(qemu_exec_t)
+## <desc>
+## <p>
+## Allow qemu to use nfs file systems
+## </p>
+## </desc>
+gen_tunable(qemu_use_nfs, true)
+
+## <desc>
+## <p>
+## Allow qemu to use usb devices
+## </p>
+## </desc>
+gen_tunable(qemu_use_usb, true)
 
 virt_domain_template(qemu)
-role qemu_roles types qemu_t;
+role system_r types qemu_t;
 
 ########################################
 #
-# Local policy
+# qemu local policy
 #
 
+storage_raw_write_removable_device(qemu_t)
+storage_raw_read_removable_device(qemu_t)
+
+userdom_search_user_home_content(qemu_t)
+userdom_read_user_tmp_files(qemu_t)
+userdom_stream_connect(qemu_t)
+
 tunable_policy(`qemu_full_network',`
+	allow qemu_t self:udp_socket create_socket_perms;
+
 	corenet_udp_sendrecv_generic_if(qemu_t)
 	corenet_udp_sendrecv_generic_node(qemu_t)
 	corenet_udp_sendrecv_all_ports(qemu_t)
@@ -37,21 +67,57 @@ tunable_policy(`qemu_full_network',`
 	corenet_tcp_connect_all_ports(qemu_t)
 ')
 
+tunable_policy(`qemu_use_cifs',`
+	fs_manage_cifs_dirs(qemu_t)
+	fs_manage_cifs_files(qemu_t)
+')
+
+tunable_policy(`qemu_use_comm',`
+	term_use_unallocated_ttys(qemu_t)
+	dev_rw_printer(qemu_t)
+')
+
+tunable_policy(`qemu_use_nfs',`
+	fs_manage_nfs_dirs(qemu_t)
+	fs_manage_nfs_files(qemu_t)
+')
+
+tunable_policy(`qemu_use_usb',`
+	dev_rw_usbfs(qemu_t)
+	fs_manage_dos_dirs(qemu_t)
+	fs_manage_dos_files(qemu_t)
+')
+
 optional_policy(`
-	xserver_user_x_domain_template(qemu, qemu_t, qemu_tmpfs_t)
+	dbus_read_lib_files(qemu_t)
 ')
 
-########################################
-#
-# Unconfined local policy
-#
+optional_policy(`
+	pulseaudio_manage_home_files(qemu_t)
+	pulseaudio_stream_connect(qemu_t)
+')
+
+optional_policy(`
+	tunable_policy(`qemu_use_cifs',`
+		samba_domtrans_smbd(qemu_t)
+	')
+')
 
 optional_policy(`
-	type unconfined_qemu_t;
-	typealias unconfined_qemu_t alias qemu_unconfined_t;
-	application_type(unconfined_qemu_t)
-	unconfined_domain(unconfined_qemu_t)
+	virt_domtrans_bridgehelper(qemu_t)
+')
+
+optional_policy(`
+	virt_manage_home_files(qemu_t)
+	virt_manage_images(qemu_t)
+	virt_append_log(qemu_t)
+')
 
-	allow unconfined_qemu_t self:process { execstack execmem };
-	allow unconfined_qemu_t qemu_exec_t:file execmod;
+optional_policy(`
+	xen_rw_image_files(qemu_t)
+')
+
+optional_policy(`
+	xserver_read_xdm_pid(qemu_t)
+	xserver_stream_connect(qemu_t)
 ')
Index: serefpolicy-contrib-20140730/qmail.fc
===================================================================
--- serefpolicy-contrib-20140730.orig/qmail.fc
+++ serefpolicy-contrib-20140730/qmail.fc
@@ -1,22 +1,6 @@
-/etc/qmail(/.*)?	gen_context(system_u:object_r:qmail_etc_t,s0)
 
-/usr/bin/tcp-env	--	gen_context(system_u:object_r:qmail_tcp_env_exec_t,s0)
-
-/usr/sbin/qmail-clean	--	gen_context(system_u:object_r:qmail_clean_exec_t,s0)
-/usr/sbin/qmail-getpw	--	gen_context(system_u:object_r:qmail_exec_t,s0)
-/usr/sbin/qmail-inject	--	gen_context(system_u:object_r:qmail_inject_exec_t,s0)
-/usr/sbin/qmail-local	--	gen_context(system_u:object_r:qmail_local_exec_t,s0)
-/usr/sbin/qmail-lspawn	--	gen_context(system_u:object_r:qmail_lspawn_exec_t,s0)
-/usr/sbin/qmail-queue	--	gen_context(system_u:object_r:qmail_queue_exec_t,s0)
-/usr/sbin/qmail-remote	--	gen_context(system_u:object_r:qmail_remote_exec_t,s0)
-/usr/sbin/qmail-rspawn	--	gen_context(system_u:object_r:qmail_rspawn_exec_t,s0)
-/usr/sbin/qmail-send	--	gen_context(system_u:object_r:qmail_send_exec_t,s0)
-/usr/sbin/qmail-smtpd	--	gen_context(system_u:object_r:qmail_smtpd_exec_t,s0)
-/usr/sbin/qmail-start	--	gen_context(system_u:object_r:qmail_start_exec_t,s0)
-/usr/sbin/splogger	--	gen_context(system_u:object_r:qmail_splogger_exec_t,s0)
-
-/var/qmail/alias	-d	gen_context(system_u:object_r:qmail_alias_home_t,s0)
-/var/qmail/alias(/.*)?	gen_context(system_u:object_r:qmail_alias_home_t,s0)
+/var/qmail/alias		-d	gen_context(system_u:object_r:qmail_alias_home_t,s0)
+/var/qmail/alias(/.*)?			gen_context(system_u:object_r:qmail_alias_home_t,s0)
 
 /var/qmail/bin/qmail-clean	--	gen_context(system_u:object_r:qmail_clean_exec_t,s0)
 /var/qmail/bin/qmail-getpw	--	gen_context(system_u:object_r:qmail_exec_t,s0)
@@ -29,9 +13,36 @@
 /var/qmail/bin/qmail-send	--	gen_context(system_u:object_r:qmail_send_exec_t,s0)
 /var/qmail/bin/qmail-smtpd	--	gen_context(system_u:object_r:qmail_smtpd_exec_t,s0)
 /var/qmail/bin/qmail-start	--	gen_context(system_u:object_r:qmail_start_exec_t,s0)
-/var/qmail/bin/splogger	--	gen_context(system_u:object_r:qmail_splogger_exec_t,s0)
-/var/qmail/bin/tcp-env	--	gen_context(system_u:object_r:qmail_tcp_env_exec_t,s0)
+/var/qmail/bin/splogger		--	gen_context(system_u:object_r:qmail_splogger_exec_t,s0)
+/var/qmail/bin/tcp-env		--	gen_context(system_u:object_r:qmail_tcp_env_exec_t,s0)
+
+/var/qmail/control(/.*)?		gen_context(system_u:object_r:qmail_etc_t,s0)
+/var/qmail/owners(/.*)?		gen_context(system_u:object_r:qmail_etc_t,s0)
+
+/var/qmail/queue(/.*)?			gen_context(system_u:object_r:qmail_spool_t,s0)
+
+ifdef(`distro_debian', `
+/etc/qmail(/.*)?			gen_context(system_u:object_r:qmail_etc_t,s0)
+
+/usr/bin/tcp-env		--	gen_context(system_u:object_r:qmail_tcp_env_exec_t,s0)
+
+#/usr/bin/serialmail/.*	--	gen_context(system_u:object_r:qmail_serialmail_exec_t,s0)
+
+/usr/sbin/qmail-clean		--	gen_context(system_u:object_r:qmail_clean_exec_t,s0)
+/usr/sbin/qmail-getpw		--	gen_context(system_u:object_r:qmail_exec_t,s0)
+/usr/sbin/qmail-inject		--	gen_context(system_u:object_r:qmail_inject_exec_t,s0)
+/usr/sbin/qmail-local		--	gen_context(system_u:object_r:qmail_local_exec_t,s0)
+/usr/sbin/qmail-lspawn		--	gen_context(system_u:object_r:qmail_lspawn_exec_t,s0)
+/usr/sbin/qmail-queue		--	gen_context(system_u:object_r:qmail_queue_exec_t,s0)
+/usr/sbin/qmail-remote		--	gen_context(system_u:object_r:qmail_remote_exec_t,s0)
+/usr/sbin/qmail-rspawn		--	gen_context(system_u:object_r:qmail_rspawn_exec_t,s0)
+/usr/sbin/qmail-send		--	gen_context(system_u:object_r:qmail_send_exec_t,s0)
+/usr/sbin/qmail-smtpd		--	gen_context(system_u:object_r:qmail_smtpd_exec_t,s0)
+/usr/sbin/qmail-start		--	gen_context(system_u:object_r:qmail_start_exec_t,s0)
+/usr/sbin/splogger		--	gen_context(system_u:object_r:qmail_splogger_exec_t,s0)
+
+/var/qmail(/.*)?			gen_context(system_u:object_r:qmail_etc_t,s0)
 
-/var/qmail(/.*)?	gen_context(system_u:object_r:qmail_etc_t,s0)
+/var/spool/qmail(/.*)?			gen_context(system_u:object_r:qmail_spool_t,s0)
+')
 
-/var/spool/qmail(/.*)?	gen_context(system_u:object_r:qmail_spool_t,s0)
